program DoLists ;        { 垩    (婫) }
Uses
    winCrt;
Type
NodePointer = ^Node;
Node = Record
     num : integer;
     Next : NodePointer;
end;

Var
Start,Q   : NodePointer;
K         : integer;
ch,Option : char;


{
        ᨫ 嘪 ⦬ 棙
}
Function NewNode:NodePointer;
Var
L  : NodePointer;
begin
     new(L);
     NewNode:=L;
end;

{
         棙  婫
}
procedure insert (num : integer; Var Head :NodePointer);
Var
L : NodePointer;
Begin
asm
        mov cx, num            { cx <- num }

        call  NewNode          {   NewNode    棙 }
        mov [bp-04], ax        { ax <- offset    new(L)}
        mov [bp-02], dx        { dx <- segment   }

        mov cx, num            { cx <- num }
        les di, L               { L^.num := num; }
        mov es:[di],cx

        les di,Head             { 樫ਫ਼  Start ,L^.Next := Start;}
        mov ax,es:[di]          { offset }
        mov dx,es:[di+2]        { segment }

        les di,L                { 樫ਫ਼  L^.Next }
        mov es:[di+2],ax
        mov es:[di+4],dx


        mov ax,[bp-04]          { Start:= L }
        mov dx,[bp-02]


        les di, Head
        mov es:[di],ax
        mov es:[di+2],dx

end;
end;


{
        㫞 棙  婫
}
Function search(num :integer;Head :NodePointer):NodePointer;
Var
L: NodePointer;
Begin
asm
        mov ax,[bp+4]          { L:=Start }
        mov dx,[bp+6]

        mov [bp-08], ax
        mov [bp-06], dx

        mov cx,num              { cx <- num }

@Begin_While:
        mov ax, [bp-08]         { While (L<> NIL) and }
        mov dx, [bp-06]
        or  ax,dx
        cmp ax,0
        je  @Exit_While

        les di,L                {(L^.num <> num)Do}
        mov bx,es:[di]
        cmp bx,cx
        je @Exit_While

        les di,L
        mov ax,es:[di+02]       { L := L^.Next;}
        mov dx,es:[di+04]

        mov [bp-08], ax
        mov [bp-06], dx

        jmp @Begin_While        { Loop }
@Exit_While:

end;
search:=L
end;


{
         棙  婫
}
procedure delete(num :integer;Var Head : NodePointer);
Var
L,P : NodePointer;
Begin

{ Assembly Code}
asm
        les di,Head
        mov ax,es:[di]          { L:=Start }
        mov dx,es:[di+2]

        mov [bp-04],ax
        mov [bp-02],dx

        xor ax,ax
        mov [bp-08],ax          { P:=Nil }
        mov [bp-06],ax

        mov cx,num
@Begin_While:
        mov ax, [bp-04]         { While (L<> NIL) and }
        mov dx, [bp-02]
        or  ax,dx
        cmp ax,0
        je  @Exit_While

        les di,L                {(L^.num <> num)Do}
        mov bx,es:[di]
        cmp bx,cx
        je @Exit_While

        mov ax,[bp-04]          {P := L }
        mov dx,[bp-02]

        mov [bp-08],ax
        mov [bp-06],dx


        les di,L
        mov ax,es:[di+02]       { L := L^.Next;}
        mov dx,es:[di+04]

        mov [bp-04], ax
        mov [bp-02], dx

        jmp @Begin_While   { Loop }
@Exit_While:

        mov ax, [bp-04]         { if (L<> NIL) and }
        mov dx, [bp-02]
        or  ax,dx
        cmp ax,0
        je  @Exit_Out_If

        les di,L                {(L^.num = num) then}
        mov bx,es:[di]
        cmp bx,num
        jne @Exit_Out_If


        les di,L                { Load L^.next }
        mov bx,es:[di+2]
        mov cx,es:[di+4]

        mov ax, [bp-08]         { if P<> NIL then }
        mov dx, [bp-06]
        or  ax,dx
        cmp ax,0
        je  @In_ElseIf

        les di,P                { P^.Next := L^.Next }
        mov es:[di+2],bx
        mov es:[di+4],cx
        jmp @Exit_Out_If

@In_ElseIf:
        les di,Head             { Start := L^.Next }
        mov es:[di],bx
        mov es:[di+02],cx
@Exit_Out_If:
end;
end;

{
         ᤠ  棙  婫
}
procedure ShowList;
Var
L : NodePointer;
Begin
	L := Start;
	While L<> NIL Do
	begin
		write(L^.num,'  ');
		L := L^.Next;
	end;
	writeln;
end;

procedure menu(Var opt :char; Row,Col :byte);
begin
	gotoxy(Col,Row);   writeln('1. ');
	gotoxy(Col,Row+1); writeln('2. ᤠ');
	gotoxy(Col,Row+2); writeln('3. 㫞');
	gotoxy(Col,Row+3); writeln('4. ');
	gotoxy(Col,Row+4); writeln('5. 륦');
	gotoxy(Col,Row+5); opt:=readkey;
end;

Begin

repeat
	clrscr;
	menu(Option,8,20);
	clrscr;
	case Option of
	     '1' : begin
	           repeat
		         gotoxy(1,1);
			 write('驜 ⤘ : ');
			 readln(k);
			 insert(k,Start);
			 gotoxy(20,15);Write('⮜');
			 ch:=readkey;
			 ClrScr;
		   until  ch In ['N','n'];
		   end;
	     '2' : begin
	                 If Start <> Nil then
			     ShowList
			 else
			     writeln('ꛜ 婫');

			 gotoxy(20,15);Write('⮜');
	                 ch:=readkey;
	            end;
	     '3' : begin
	                if Start <> Nil then
		        begin
			     gotoxy(1,1);
			     write('驜     : ');
			     readln(k);
			     Q:=search(k,Start);
                             if Q<> Nil then
                                writeln('⤦ :',Q^.num);
			end
			else
			    writeln('ꛜ 婫');

			gotoxy(20,15);Write('⮜');
			ch:=readkey;
	            end;
	     '4' : begin
	                if Start <> Nil then
			begin
			     gotoxy(1,1);
			     write('驜     : ');
			     readln(k);
			     delete(k,Start);
			end
			else
			     writeln('ꛜ 婫');

			gotoxy(20,15);Write('⮜');
			ch:=readkey;
	            end;

	end;
 until Option = '5';

End.

